/******************/
/*   Mouse Demo   */
/*       by       */
/*  Ron Balewski  */
/******************/
 
#include <dos.h>      /*  REGS registers  */
#include <conio.h>
#include <stdio.h>
 
main()
{
   int exitflag;
   union REGS regs;
 
   clrscr();
   regs.x.ax = 0;                  /* Function 0:       */
   int86(0x33, &regs, &regs);      /* Test mouse status */
 
   if (regs.x.ax != 0xffff)            /* Test for good mouse  */
      {
      printf("\n\nMouse problem!!! \n\n\n");
      exit(8);
      }
 
 
   gotoxy(1, 1);
   printf("ͻ\n"     /*  Draw  */
          "     Mouse Statistics   \n"     /* Pretty */
          "Ķ\n"     /* Screen */
          "                        \n"
          " Position \n"
          "                      \n"
          "  Horizontal ->       \n"
          "  Vertical   ->       \n"
          "                      \n"
          "  \n"
          "                        \n"
          " Buttons \n"
          "                      \n"
          "     Left --->        \n"
          "     Center ->        \n"
          "     Right -->        \n"
          "                      \n"
          "   'X' = Pressed Ĵ \n"
          "  \n"
          "                        \n"
          "\n");
 
   gotoxy(60, 20);
   printf("ͻ");
   gotoxy(60, 21);
   printf("        ");
   gotoxy(60, 22);
   printf("  EXIT  ");
   gotoxy(60, 23);
   printf("        ");
   gotoxy(60, 24);
   printf("");
 
 
   regs.x.ax = 1;                  /* Function 1:           */
   int86(0x33, &regs, &regs);      /* Turn on mouse cursor  */
 
   exitflag = 0;
   while (exitflag == 0)
      {
 
      regs.x.ax = 3;                  /* Function 3:          */
      int86(0x33, &regs, &regs);      /* Read mouse position  */
 
      gotoxy(19, 7);                  /* Print horiz. position  */
      printf("%3d", regs.x.cx);
 
      gotoxy(19, 8);                  /*  Print vert. position  */
      printf("%3d", regs.x.dx);
 
 
      gotoxy(19, 14);                 /*  Test left button  */
      if ((regs.x.bx & 0x01) == 0x01)
         putchar('X');
      else
         putchar(' ');
 
      gotoxy(19, 15);                /*  Test center button  */
      if ((regs.x.bx & 0x04) == 0x04)
         putchar('X');
      else
         putchar(' ');
 
      gotoxy(19, 16);               /*  Test right button  */
      if ((regs.x.bx & 0x02) == 0x02)
         putchar('X');
      else
         putchar(' ');
 
 
/*  Now we'll check for the EXIT by watching for a left button   */
/*  click, then checking for the location.  We'll use function 5 */
/*  for this.  We don't have to do this, since we already have   */
/*  the button status & location.  But we'll do it anyway for    */
/*  demonstration purposes.                                      */
 
 
      regs.x.ax = 5;                     /* Function 5:           */
      regs.x.bx = 0; /* Left button */   /* Get button press info */
      int86(0x33, &regs, &regs);
 
      if ((regs.x.cx>472)&&(regs.x.cx<544)&&
          (regs.x.dx>152)&&(regs.x.dx<184))
         exitflag = 1;
      }
   regs.x.ax = 0;             /*  We've got to reset the mouse  */
   int86(0x33, &regs, &regs); /*  or the cursor will stay visible! */
}
